#include "time.h"
#include "lwip/debug.h"

#include "lwip/mem.h"
#include "lwip/memp.h"
#include "lwip/sys.h"

#include "lwip/stats.h"

#include "lwip/ip.h"
#include "lwip/udp.h"
#include "lwip/tcp.h"
#include "lwip/arch/gc/include/netif/gcif.h"
#include "netif/etharp.h"

#include "dolup.h"
#include "irq.h"

#include "console.h"

extern void httpd_start();
struct ip_addr *sram_get_ip(int w);

static struct netif netif;
static tb_t now, start;

void network_init()
{
	struct ip_addr *ipaddr = sram_get_ip(0), *netmask = sram_get_ip(1), *gw = sram_get_ip(2);

#ifdef STATS
	stats_init();
#endif /* STATS */

	mem_init();
	memp_init();
	pbuf_init(); 
	netif_init();
	ip_init();
//	udp_init();
	tcp_init();
	etharp_init();

	if (!netif_add(&netif, ipaddr, netmask, gw, NULL, gcif_init, ip_input))
	{
		printf("netif_add failed!\n");
		return;
	}
	
	netif_set_default(&netif);
	
	dolup_init();
	httpd_start();

	mftb(&start);
}

void network_poll()
{
	mftb(&now);
	if (tb_diff_msec(&now, &start) >= 250)
	{
		unsigned long flags;
		mftb(&start);
		cli(flags);
		tcp_tmr();
		sti(flags);
	}
}
