#include "ipl.h"
#include "pad.h"
#include "lwip/ip_addr.h"
#include "lwip/inet.h"

void sram_set_videomode(int v)
{
	sram_data[33] = v;
}

int sram_get_videomode(void)
{
	return sram_data[33];
}

void sram_set_autoboot(int v)
{
	sram_data[34] = v;
}

int sram_get_autoboot(void)
{
	return sram_data[34];
}

struct ip_addr *sram_get_ip(int w)
{
	return (struct ip_addr*)(sram_data + 0x24 + w * 4);
}

void sram_load_defaults(void)
{
	sram_data[32] = '!';
	
	sram_set_autoboot(0);
	sram_set_videomode(1);
	IP4_ADDR(sram_get_ip(0), 10,0,0,203);
	IP4_ADDR(sram_get_ip(1), 255,255,255,0);
	IP4_ADDR(sram_get_ip(2), 10,0,0,1);
}

void read_sram(void)
{
	//TODO: this somewhere else
	struct PAD pad;
	PAD_ReadState(&pad, 0);
	
	if (!pad.Digital.Start)
		exi_sram_read(sram_data);
	else
		memset(sram_data + 32, 0, 32);
	
	if (sram_data[32] != '!')
		sram_load_defaults();
}

void write_sram(void)
{
	exi_sram_write(sram_data);
}
